//=======================================================================================
//牌山を生成関連のプログラム
//牌山生成、牌山シャッフル
//擬似乱数生成器「Mersenne Twister in JavaScript」と併用
//(C)nyankosan　2016-10-22
//=======================================================================================

//============================================================================
//牌山の配列：JSON形式
//============================================================================
var paiYama = [
	{"No":0,"paiName":"一萬","paiNo":1},
	{"No":1,"paiName":"一萬","paiNo":1},
	{"No":2,"paiName":"一萬","paiNo":1},
	{"No":3,"paiName":"一萬","paiNo":1},
	{"No":4,"paiName":"二萬","paiNo":2},
	{"No":5,"paiName":"二萬","paiNo":2},
	{"No":6,"paiName":"二萬","paiNo":2},
	{"No":7,"paiName":"二萬","paiNo":2},
	{"No":8,"paiName":"三萬","paiNo":3},
	{"No":9,"paiName":"三萬","paiNo":3},
	{"No":10,"paiName":"三萬","paiNo":3},
	{"No":11,"paiName":"三萬","paiNo":3},
	{"No":12,"paiName":"四萬","paiNo":4},
	{"No":13,"paiName":"四萬","paiNo":4},
	{"No":14,"paiName":"四萬","paiNo":4},
	{"No":15,"paiName":"四萬","paiNo":4},
	{"No":16,"paiName":"赤五萬","paiNo":0},
	{"No":17,"paiName":"五萬","paiNo":5},
	{"No":18,"paiName":"五萬","paiNo":5},
	{"No":19,"paiName":"五萬","paiNo":5},
	{"No":20,"paiName":"六萬","paiNo":6},
	{"No":21,"paiName":"六萬","paiNo":6},
	{"No":22,"paiName":"六萬","paiNo":6},
	{"No":23,"paiName":"六萬","paiNo":6},
	{"No":24,"paiName":"七萬","paiNo":7},
	{"No":25,"paiName":"七萬","paiNo":7},
	{"No":26,"paiName":"七萬","paiNo":7},
	{"No":27,"paiName":"七萬","paiNo":7},
	{"No":28,"paiName":"八萬","paiNo":8},
	{"No":29,"paiName":"八萬","paiNo":8},
	{"No":30,"paiName":"八萬","paiNo":8},
	{"No":31,"paiName":"八萬","paiNo":8},
	{"No":32,"paiName":"九萬","paiNo":9},
	{"No":33,"paiName":"九萬","paiNo":9},
	{"No":34,"paiName":"九萬","paiNo":9},
	{"No":35,"paiName":"九萬","paiNo":9},

	{"No":36,"paiName":"一筒","paiNo":11},
	{"No":37,"paiName":"一筒","paiNo":11},
	{"No":38,"paiName":"一筒","paiNo":11},
	{"No":39,"paiName":"一筒","paiNo":11},
	{"No":40,"paiName":"二筒","paiNo":12},
	{"No":41,"paiName":"二筒","paiNo":12},
	{"No":42,"paiName":"二筒","paiNo":12},
	{"No":43,"paiName":"二筒","paiNo":12},
	{"No":44,"paiName":"三筒","paiNo":13},
	{"No":45,"paiName":"三筒","paiNo":13},
	{"No":46,"paiName":"三筒","paiNo":13},
	{"No":47,"paiName":"三筒","paiNo":13},
	{"No":48,"paiName":"四筒","paiNo":14},
	{"No":49,"paiName":"四筒","paiNo":14},
	{"No":50,"paiName":"四筒","paiNo":14},
	{"No":51,"paiName":"四筒","paiNo":14},
	{"No":52,"paiName":"赤五筒","paiNo":10},
	{"No":53,"paiName":"五筒","paiNo":15},
	{"No":54,"paiName":"五筒","paiNo":15},
	{"No":55,"paiName":"五筒","paiNo":15},
	{"No":56,"paiName":"六筒","paiNo":16},
	{"No":57,"paiName":"六筒","paiNo":16},
	{"No":58,"paiName":"六筒","paiNo":16},
	{"No":59,"paiName":"六筒","paiNo":16},
	{"No":60,"paiName":"七筒","paiNo":17},
	{"No":61,"paiName":"七筒","paiNo":17},
	{"No":62,"paiName":"七筒","paiNo":17},
	{"No":63,"paiName":"七筒","paiNo":17},
	{"No":64,"paiName":"八筒","paiNo":18},
	{"No":65,"paiName":"八筒","paiNo":18},
	{"No":66,"paiName":"八筒","paiNo":18},
	{"No":67,"paiName":"八筒","paiNo":18},
	{"No":68,"paiName":"九筒","paiNo":19},
	{"No":69,"paiName":"九筒","paiNo":19},
	{"No":70,"paiName":"九筒","paiNo":19},
	{"No":71,"paiName":"九筒","paiNo":19},

	{"No":72,"paiName":"一索","paiNo":21},
	{"No":73,"paiName":"一索","paiNo":21},
	{"No":74,"paiName":"一索","paiNo":21},
	{"No":75,"paiName":"一索","paiNo":21},
	{"No":76,"paiName":"二索","paiNo":22},
	{"No":77,"paiName":"二索","paiNo":22},
	{"No":78,"paiName":"二索","paiNo":22},
	{"No":79,"paiName":"二索","paiNo":22},
	{"No":80,"paiName":"三索","paiNo":23},
	{"No":81,"paiName":"三索","paiNo":23},
	{"No":82,"paiName":"三索","paiNo":23},
	{"No":83,"paiName":"三索","paiNo":23},
	{"No":84,"paiName":"四索","paiNo":24},
	{"No":85,"paiName":"四索","paiNo":24},
	{"No":86,"paiName":"四索","paiNo":24},
	{"No":87,"paiName":"四索","paiNo":24},
	{"No":88,"paiName":"赤五索","paiNo":20},
	{"No":89,"paiName":"五索","paiNo":25},
	{"No":90,"paiName":"五索","paiNo":25},
	{"No":91,"paiName":"五索","paiNo":25},
	{"No":92,"paiName":"六索","paiNo":26},
	{"No":93,"paiName":"六索","paiNo":26},
	{"No":94,"paiName":"六索","paiNo":26},
	{"No":95,"paiName":"六索","paiNo":26},
	{"No":96,"paiName":"七索","paiNo":27},
	{"No":97,"paiName":"七索","paiNo":27},
	{"No":98,"paiName":"七索","paiNo":27},
	{"No":99,"paiName":"七索","paiNo":27},
	{"No":100,"paiName":"八索","paiNo":28},
	{"No":101,"paiName":"八索","paiNo":28},
	{"No":102,"paiName":"八索","paiNo":28},
	{"No":103,"paiName":"八索","paiNo":28},
	{"No":104,"paiName":"九索","paiNo":29},
	{"No":105,"paiName":"九索","paiNo":29},
	{"No":106,"paiName":"九索","paiNo":29},
	{"No":107,"paiName":"九索","paiNo":29},

	{"No":108,"paiName":"東","paiNo":31},
	{"No":109,"paiName":"東","paiNo":31},
	{"No":110,"paiName":"東","paiNo":31},
	{"No":111,"paiName":"東","paiNo":31},
	{"No":112,"paiName":"南","paiNo":32},
	{"No":113,"paiName":"南","paiNo":32},
	{"No":114,"paiName":"南","paiNo":32},
	{"No":115,"paiName":"南","paiNo":32},
	{"No":116,"paiName":"西","paiNo":33},
	{"No":117,"paiName":"西","paiNo":33},
	{"No":118,"paiName":"西","paiNo":33},
	{"No":119,"paiName":"西","paiNo":33},
	{"No":120,"paiName":"北","paiNo":34},
	{"No":121,"paiName":"北","paiNo":34},
	{"No":122,"paiName":"北","paiNo":34},
	{"No":123,"paiName":"北","paiNo":34},
	{"No":124,"paiName":"白","paiNo":35},
	{"No":125,"paiName":"白","paiNo":35},
	{"No":126,"paiName":"白","paiNo":35},
	{"No":127,"paiName":"白","paiNo":35},
	{"No":128,"paiName":"發","paiNo":36},
	{"No":129,"paiName":"發","paiNo":36},
	{"No":130,"paiName":"發","paiNo":36},
	{"No":131,"paiName":"發","paiNo":36},
	{"No":132,"paiName":"中","paiNo":37},
	{"No":133,"paiName":"中","paiNo":37},
	{"No":134,"paiName":"中","paiNo":37},
	{"No":135,"paiName":"中","paiNo":37}
];

//グローバル変数==============================================================
var yama = new Array(135);//牌山の配列：136牌
//==============================================================================
//元になる牌山を生成する関数
function makePaiYama(){
	var i;
	for(i=0;i<136;i++){
		yama[i] = paiYama[i].paiNo;
	}
}
//==============================================================================
//牌山をシャッフルする関数【Mersenne Twister in JavaScriptを利用】
function shufflePaiYama(){
    var mt = new MersenneTwister();//Mersenne­Twister オブジェクトの初期化
	var i,j,k;
	for(i=135;i>0;i--){
    	j = mt.nextInt(0, 135);  // 0 以上 135 未満の乱数（整数）を発生させる
        k = yama[i];//変数kに退避
		yama[i] = yama[j];//乱数で発生した番地の牌を代入する
		yama[j] = k;//変数Kから戻す
	}
}
//=======================================================================================
