//=======================================================================================
//第一ツモをツモった時のシャンテン数調べるプログラム
//サイコロノを振る、シャンテン数を算出する、指定した回数試行して各シャンテン数を出力する
//擬似乱数生成器「Mersenne Twister in JavaScript」と併用
//(C)nyankosan　2016-10-22
//=======================================================================================

//グローバル変数==============================================================
var stopFlg=0;//繰り返し処理に割り込んで中断させるためのフラグ
var haipaiSyanten = [0,0,0,0,0,0,0,0,0];//シャンテン数を格納する配列
var numTrials = 1000;//試行回数：この値を変えることで試行回数を調整できます
var count = 1;//試行回数をカウント
//=======================================================================================
//サイコロの目を出す関数
//spotsmin以上spotsmax以下の乱数が生成される。【(最大値 - 最小値 + 1) + 最小値】
function makeSpotsDice(){
	var spotsmax = 6;//最大値
	var spotsmin = 1;//最小値
	var spotsdice = Math.random()*(spotsmax - spotsmin + 1) + spotsmin;//
	spotsdice = Math.floor(spotsdice); //少数以下を丸める
	return spotsdice;
}
//==============================================================================
$("#startBtn").click(function() {
	var syanten_suu=0;//シャンテン数
	var dice = 0;//サイコロの目

	//初期化
	//count = 1;//試行回数カウント
	count = 0;//試行回数カウント
	stopFlg = 0;//中断フラグの初期化
	haipaiSyanten = [0,0,0,0,0,0,0,0,0];

	//要素のキャッシュ
	var cachepaiTehai = $("#paiTehai");
	var cacheSyantenCount = $("#SyantenCount");
	var cacheSyantenCheck = $("#SyantenCheck");


	//一定時間ごとに処理を繰り返させる処理
	var timer = setInterval(function(){
		//手牌の初期化
		tehai = [0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0];

		makePaiYama();//牌山を生成する関数を呼び出す
		shufflePaiYama();//牌山をシャッフルする関数を呼び出す
		dice = makeSpotsDice() + makeSpotsDice();//サイコロを振る

		count++;
		//サイコロの目に合わせて取り出した牌を表示する
		(function (){
			var yamaNo;
			var paiNo13 = dice*2 + 16*3;//親が取り出す13牌目の番地
			var paiNo14 = paiNo13 +4;//親が取り出す14牌目の番地
			var paiga="";
			cachepaiTehai.empty();
			//配牌を牌山の1～3ブロックまでを取り出す処理
			for(var i=0;i<3;i++){
				for(var j=0;j<4;j++){
					yamaNo = dice*2 + j + 16*i;//親が取り出す牌の番地
					tehai[yama[yamaNo]]++;//牌番号に対応した番地に1を加算する
					paiga = "<span class=\"" + paiType[yama[yamaNo]].cssSprite + "\"></span>";//cssスプライトの牌画を配置
					cachepaiTehai.append(paiga);
				}
			}
			//13牌目を取り出す処理
			//yamaNo = dice*2 + 16*3;//親が取り出す13牌目の番地
			yamaNo = paiNo13;//親が取り出す13牌目の番地
			tehai[yama[yamaNo]]++;//牌番号に対応した番地に1を加算する
			paiga = "<span class=\"" + paiType[yama[yamaNo]].cssSprite + "\"></span>";//cssスプライトの牌画を配置
			cachepaiTehai.append(paiga);

			//第一ツモを取り出す処理
			yamaNo = paiNo14;//親が取り出す14牌目の番地
			tehai[yama[yamaNo]]++;//牌番号に対応した番地に1を加算する
			paiga = "　第一ツモ<span class=\"" + paiType[yama[yamaNo]].cssSprite + "\"></span>";//cssスプライトの牌画を配置
			cachepaiTehai.append(paiga);
		})();

		checkReddora();//赤ドラの有無をチェックする関数を呼び出す
		moveReddora();//赤ドラを配列内で移動させる

		preTempTehai = $.extend(true, [], tehai);//tehai配列のバックアップを取る
		syanten_suu = syantenCheck();//通常手のシャンテン数を調べる関数を呼び出す。

		haipaiSyanten[syanten_suu + 1]++;//シャンテン数に対応した番地に1を加算する。アガリ判定の分、ずらす。

		//試行回数を表示させる
		cacheSyantenCount.empty().append(count);

		//シャンテン数を表示させる
		cacheSyantenCheck.empty().append("シャンテン数 = " + (syanten_suu) );

		//繰り返し処理を終了させる処理
		//if(count++ == (numTrials - 1)||stopFlg==1){
		if(count == numTrials||stopFlg==1){
			clearInterval(timer);
		}
	}, 100);//0.1秒毎に処理を実行する

});
//==============================================================================
//中断ボタンの処理
$("#stopBtn").click(function() {
	stopFlg = 1;//停止のフラグを立てる
});
//=======================================================================================
//シャンテン数の合計を出力する処理
$("#outputSyantenBtn").click(function() {
	//要素のキャッシュ
	var cacheSyantenCheck = $("#SyantenCheck");

	//各シャンテン数を表示させる
	//cacheSyantenCheck.empty().append("試行回数：" + (count - 1) + "回<br>");
	cacheSyantenCheck.empty().append("試行回数：" + count + "回<br>");
	for(var i=0;i<9;i++){
		//cacheSyantenCheck.append("シャンテン数 = " + i + " ： " + haipaiSyanten[i] + "回：" + persentSyanten(haipaiSyanten[i],count - 1) + "%<br>");
		cacheSyantenCheck.append("シャンテン数 = " + (i -1) + " ： " + haipaiSyanten[i] + "回：" + persentSyanten(haipaiSyanten[i],count) + "%<br>");
	}
});
//=======================================================================================
//集計結果をパーセント表記に変換する関数
function persentSyanten(syanten_kyokusuu,num){
	var result;
	if(syanten_kyokusuu>0){
		result = Math.floor((syanten_kyokusuu/num)*10000)/100;//パーセント小数2桁
	}else{
		result = 0;
	}
	return result;
}
